diff --git a/src/lib/bb-daemon.ts b/src/lib/bb-daemon.ts
new file mode 100644
index 0000000..2aa44d2
--- /dev/null
+++ b/src/lib/bb-daemon.ts
@@ -0,0 +1,219 @@
+import { embeddedPiDaemon, type HostDaemonStatus } from './embedded-daemon';
+import type { LaunchSurface, RuntimeConsoleEvent, RuntimeInstance } from './embedded-runtime';
+import { createPiDaemonAdapter, type PiDaemonAdapter } from './pi-daemon-adapter';
+import { detectPiRuntimeStrategy, type PiRuntimeResolution } from './pi-runtime-detection';
+import type { BeadIssue } from './types';
+
+export type BbDaemonLifecycleStatus = 'stopped' | 'starting' | 'running' | 'stopping' | 'failed';
+
+export interface BbDaemonLifecycle {
+  status: BbDaemonLifecycleStatus;
+  startedAt: string | null;
+  stoppedAt: string | null;
+  lastError: string | null;
+}
+
+export interface RuntimeEventSubscriptionOptions {
+  projectRoot?: string;
+}
+
+export interface BbDaemonStatus extends HostDaemonStatus {
+  lifecycle: BbDaemonLifecycle;
+  piRuntime: PiRuntimeResolution | null;
+}
+
+export interface BbDaemon {
+  start(): Promise<BbDaemonLifecycle>;
+  stop(): Promise<BbDaemonLifecycle>;
+  ensureRunning(): Promise<BbDaemonLifecycle>;
+  getLifecycle(): BbDaemonLifecycle;
+  getStatus(): BbDaemonStatus;
+  getPiRuntime(): PiRuntimeResolution | null;
+  ensureProject(projectRoot: string): { projectRoot: string; orchestratorId: string };
+  ensureOrchestrator(projectRoot: string): Promise<RuntimeInstance>;
+  listEvents(projectRoot: string): RuntimeConsoleEvent[];
+  subscribeRuntimeEvents(listener: (event: RuntimeConsoleEvent) => void, options?: RuntimeEventSubscriptionOptions): () => void;
+  launchFromIssue(params: {
+    projectRoot: string;
+    issue: BeadIssue;
+    origin: LaunchSurface;
+    swarmId?: string | null;
+  }): Promise<{ orchestrator: RuntimeInstance; events: RuntimeConsoleEvent[] }>;
+  prompt(projectRoot: string, text: string): Promise<void>;
+  resetForTests(): void;
+}
+
+function createInitialLifecycle(): BbDaemonLifecycle {
+  return {
+    status: 'stopped',
+    startedAt: null,
+    stoppedAt: null,
+    lastError: null,
+  };
+}
+
+interface RuntimeEventSubscriber {
+  projectRoot?: string;
+  listener: (event: RuntimeConsoleEvent) => void;
+}
+
+class InProcessBbDaemon implements BbDaemon {
+  private lifecycle: BbDaemonLifecycle = createInitialLifecycle();
+  private readonly adapter: PiDaemonAdapter;
+  private readonly subscribers = new Map<number, RuntimeEventSubscriber>();
+  private nextSubscriberId = 1;
+  private piRuntime: PiRuntimeResolution | null = null;
+
+  constructor(adapter: PiDaemonAdapter = createPiDaemonAdapter()) {
+    this.adapter = adapter;
+  }
+
+  async start(): Promise<BbDaemonLifecycle> {
+    if (this.lifecycle.status === 'running') {
+      return this.getLifecycle();
+    }
+
+    this.lifecycle = {
+      ...this.lifecycle,
+      status: 'starting',
+      lastError: null,
+    };
+
+    this.piRuntime = await detectPiRuntimeStrategy();
+
+    this.lifecycle = {
+      status: 'running',
+      startedAt: this.lifecycle.startedAt ?? new Date().toISOString(),
+      stoppedAt: null,
+      lastError: null,
+    };
+
+    return this.getLifecycle();
+  }
+
+  async ensureRunning(): Promise<BbDaemonLifecycle> {
+    return this.lifecycle.status === 'running' ? this.getLifecycle() : this.start();
+  }
+
+  async stop(): Promise<BbDaemonLifecycle> {
+    if (this.lifecycle.status === 'stopped') {
+      return this.getLifecycle();
+    }
+
+    this.lifecycle = {
+      ...this.lifecycle,
+      status: 'stopping',
+    };
+
+    this.lifecycle = {
+      status: 'stopped',
+      startedAt: this.lifecycle.startedAt,
+      stoppedAt: new Date().toISOString(),
+      lastError: null,
+    };
+
+    return this.getLifecycle();
+  }
+
+  getLifecycle(): BbDaemonLifecycle {
+    return { ...this.lifecycle };
+  }
+
+  getPiRuntime(): PiRuntimeResolution | null {
+    return this.piRuntime;
+  }
+
+  getStatus(): BbDaemonStatus {
+    return {
+      ...embeddedPiDaemon.getStatus(),
+      lifecycle: this.getLifecycle(),
+      piRuntime: this.getPiRuntime(),
+    };
+  }
+
+  ensureProject(projectRoot: string): { projectRoot: string; orchestratorId: string } {
+    const state = embeddedPiDaemon.ensureProject(projectRoot);
+    return {
+      projectRoot: state.projectRoot,
+      orchestratorId: state.orchestrator.id,
+    };
+  }
+
+  async ensureOrchestrator(projectRoot: string): Promise<RuntimeInstance> {
+    await this.ensureRunning();
+    const binding = await this.adapter.ensureProjectOrchestrator(projectRoot);
+    return binding.runtime;
+  }
+
+  listEvents(projectRoot: string): RuntimeConsoleEvent[] {
+    return this.adapter.listEvents(projectRoot);
+  }
+
+  subscribeRuntimeEvents(listener: (event: RuntimeConsoleEvent) => void, options: RuntimeEventSubscriptionOptions = {}): () => void {
+    const id = this.nextSubscriberId;
+    this.nextSubscriberId += 1;
+    this.subscribers.set(id, {
+      projectRoot: options.projectRoot,
+      listener,
+    });
+
+    return () => {
+      this.subscribers.delete(id);
+    };
+  }
+
+  private emitRuntimeEvents(projectRoot: string, events: RuntimeConsoleEvent[]) {
+    for (const event of events) {
+      for (const subscriber of this.subscribers.values()) {
+        if (!subscriber.projectRoot || subscriber.projectRoot === projectRoot) {
+          subscriber.listener(event);
+        }
+      }
+    }
+  }
+
+  async launchFromIssue(params: {
+    projectRoot: string;
+    issue: BeadIssue;
+    origin: LaunchSurface;
+    swarmId?: string | null;
+  }): Promise<{ orchestrator: RuntimeInstance; events: RuntimeConsoleEvent[] }> {
+    await this.ensureRunning();
+    const result = await this.adapter.launchFromIssue(params);
+    this.emitRuntimeEvents(params.projectRoot, result.events);
+    return result;
+  }
+
+  async prompt(projectRoot: string, text: string): Promise<void> {
+    await this.ensureRunning();
+
+    // Fire-and-forget the adapter prompt - adapter stores user message immediately,
+    // SDK subscription handles real-time events, SSE poller picks up from embeddedPiDaemon
+    if (typeof this.adapter.prompt === 'function') {
+      this.adapter.prompt(projectRoot, text).catch((e) => {
+        console.error('[BbDaemon] Adapter prompt error:', e);
+      });
+    }
+  }
+
+  resetForTests(): void {
+    this.lifecycle = createInitialLifecycle();
+    this.piRuntime = null;
+    embeddedPiDaemon.resetForTests();
+    this.subscribers.clear();
+    this.nextSubscriberId = 1;
+  }
+}
+
+export function createBbDaemon(adapter?: PiDaemonAdapter): BbDaemon {
+  return new InProcessBbDaemon(adapter);
+}
+
+const globalRegistry = globalThis as typeof globalThis & {
+  __beadboardBbDaemon?: BbDaemon;
+};
+
+export const bbDaemon = globalRegistry.__beadboardBbDaemon ?? createBbDaemon();
+if (!globalRegistry.__beadboardBbDaemon) {
+  globalRegistry.__beadboardBbDaemon = bbDaemon;
+}
diff --git a/src/lib/bb-pi-bootstrap.ts b/src/lib/bb-pi-bootstrap.ts
new file mode 100644
index 0000000..84370ec
--- /dev/null
+++ b/src/lib/bb-pi-bootstrap.ts
@@ -0,0 +1,194 @@
+import fs from 'node:fs/promises';
+import os from 'node:os';
+import path from 'node:path';
+import { getManagedPiPaths } from './pi-runtime-detection';
+
+export interface BootstrapManagedPiResult {
+  managedRoot: string;
+  sdkPath: string;
+  agentDir: string;
+  created: boolean;
+  alreadyInstalled: boolean;
+  installedPackages: string[];
+}
+
+export interface BootstrapManagedPiOptions {
+  version?: string;
+  home?: string;
+  output?: { write(chunk: string): void };
+  execFile?: (
+    file: string,
+    args: string[],
+    options: { cwd: string; env: NodeJS.ProcessEnv },
+  ) => Promise<void>;
+}
+
+function getManagedShellPath(): string | null {
+  if (process.platform === 'win32') {
+    return process.env.ComSpec ?? 'C:\\Windows\\System32\\cmd.exe';
+  }
+
+  const candidates = ['/bin/sh', '/usr/bin/sh', '/bin/bash', '/usr/bin/bash'];
+  return candidates.find((candidate) => require('node:fs').existsSync(candidate)) ?? null;
+}
+
+export async function ensureManagedPiSettings(agentDir: string): Promise<void> {
+  const settingsPath = path.join(agentDir, 'settings.json');
+  let settings: Record<string, unknown> = {};
+
+  try {
+    const existing = await fs.readFile(settingsPath, 'utf8');
+    settings = JSON.parse(existing) as Record<string, unknown>;
+  } catch {
+    settings = {};
+  }
+
+  const shellPath = getManagedShellPath();
+  const nextSettings = {
+    defaultProvider: settings.defaultProvider ?? null,
+    defaultModel: settings.defaultModel ?? null,
+    ...(shellPath ? { shellPath } : {}),
+    ...settings,
+  };
+
+  if (shellPath) {
+    nextSettings.shellPath = shellPath;
+  }
+
+  await fs.mkdir(agentDir, { recursive: true });
+  await fs.writeFile(settingsPath, JSON.stringify(nextSettings, null, 2) + '\n', 'utf8');
+}
+
+const AGENTS_MD_CONTENT = `# BeadBoard Orchestrator
+
+You are the BeadBoard Orchestrator, the central embedded intelligence of the BeadBoard project management and agent coordination system.
+
+## Your Role
+You are not a generic coding assistant. You are a headless, autonomous daemon responsible for coordinating work across the repository.
+
+1. **Dolt Data Awareness**: You read and understand the project's task topology via Dolt (BeadBoard's versioned SQL backend).
+2. **Mailbox Management**: You read, route, and respond to agent coordination messages (HANDOFF, BLOCKED, INFO).
+3. **Session Presence**: You broadcast your status and presence state so the BeadBoard frontend can render what you are doing in real-time.
+4. **Worker Dispatch**: You evaluate mission templates, select archetypes, and dispatch worker sub-agents to complete specific tasks.
+
+## Operating Constraints
+- You operate in a headless environment. You must NEVER prompt for human CLI input.
+- You must always query the Dolt backend before making assumptions about task state.
+- You must always acknowledge (ACK) messages in the BLOCKED or HANDOFF categories.
+`;
+
+export async function ensureManagedPiAgentsMd(agentDir: string): Promise<void> {
+  const agentsPath = path.join(agentDir, 'AGENTS.md');
+  await fs.mkdir(agentDir, { recursive: true });
+  await fs.writeFile(agentsPath, AGENTS_MD_CONTENT, 'utf8');
+}
+
+async function pathExists(target: string): Promise<boolean> {
+  try {
+    await fs.access(target);
+    return true;
+  } catch {
+    return false;
+  }
+}
+
+async function readDependencyVersions(): Promise<{ pi: string; minimatch: string }> {
+  // Use process.cwd() rather than import.meta.url: in Next.js webpack context,
+  // import.meta.url is a webpack:// URL, not a file:// URL, so fileURLToPath()
+  // would throw a cross-realm TypeError. process.cwd() reliably resolves to the
+  // project root in both dev and production Next.js server environments.
+  const packageJsonPath = path.join(process.cwd(), 'package.json');
+  const raw = await fs.readFile(packageJsonPath, 'utf8');
+  const pkg = JSON.parse(raw) as {
+    dependencies?: Record<string, string>;
+  };
+
+  return {
+    pi: pkg.dependencies?.['@mariozechner/pi-coding-agent'] ?? '^0.30.2',
+    minimatch: pkg.dependencies?.minimatch ?? '^10.2.4',
+  };
+}
+
+async function defaultExecFile(file: string, args: string[], options: { cwd: string; env: NodeJS.ProcessEnv }): Promise<void> {
+  const { execFile } = await import('node:child_process');
+  await new Promise<void>((resolve, reject) => {
+    execFile(file, args, options, (error) => {
+      if (error) {
+        reject(error);
+        return;
+      }
+      resolve();
+    });
+  });
+}
+
+function npmCommand(): string {
+  return process.platform === 'win32' ? 'npm.cmd' : 'npm';
+}
+
+export async function bootstrapManagedPi(options: BootstrapManagedPiOptions = {}): Promise<BootstrapManagedPiResult> {
+  const version = options.version ?? '0.1.0';
+  const home = options.home ?? os.homedir();
+  const output = options.output;
+  const execFile = options.execFile ?? defaultExecFile;
+  const managed = getManagedPiPaths(version, home);
+
+  if (await pathExists(managed.sdkPath)) {
+    await ensureManagedPiSettings(managed.agentDir);
+    await ensureManagedPiAgentsMd(managed.agentDir);
+    return {
+      managedRoot: managed.managedRoot,
+      sdkPath: managed.sdkPath,
+      agentDir: managed.agentDir,
+      created: false,
+      alreadyInstalled: true,
+      installedPackages: [],
+    };
+  }
+
+  const versions = await readDependencyVersions();
+
+  await fs.mkdir(managed.managedRoot, { recursive: true });
+  await fs.mkdir(managed.agentDir, { recursive: true });
+
+  await fs.writeFile(
+    path.join(managed.managedRoot, 'package.json'),
+    JSON.stringify(
+      {
+        name: 'bb-managed-pi-runtime',
+        private: true,
+        type: 'module',
+        dependencies: {
+          '@mariozechner/pi-coding-agent': versions.pi,
+          minimatch: versions.minimatch,
+        },
+      },
+      null,
+      2,
+    ) + '\n',
+    'utf8',
+  );
+
+  await ensureManagedPiSettings(managed.agentDir);
+  await ensureManagedPiAgentsMd(managed.agentDir);
+
+  output?.write(`[bb bootstrap] Installing BeadBoard agent runtime at ${managed.managedRoot}\n`);
+  await execFile(npmCommand(), ['install', '--no-package-lock', '--no-fund', '--no-audit'], {
+    cwd: managed.managedRoot,
+    env: {
+      ...process.env,
+      PATH: process.env.PATH ?? '',
+      HOME: process.env.HOME ?? home,
+    },
+  });
+  output?.write('[bb bootstrap] Agent runtime installed.\n');
+
+  return {
+    managedRoot: managed.managedRoot,
+    sdkPath: managed.sdkPath,
+    agentDir: managed.agentDir,
+    created: true,
+    alreadyInstalled: false,
+    installedPackages: ['@mariozechner/pi-coding-agent', 'minimatch'],
+  };
+}
diff --git a/src/lib/dolt-client.ts b/src/lib/dolt-client.ts
index e583848..b84e5b0 100644
--- a/src/lib/dolt-client.ts
+++ b/src/lib/dolt-client.ts
@@ -35,14 +35,42 @@ async function readDoltMetadata(projectRoot: string): Promise<DoltMetadata> {
     throw new DoltConnectionError(`Invalid JSON in ${metadataPath}`, err);
   }
 
-  const port = parsed.dolt_server_port;
   const database = parsed.dolt_database;
-  if (typeof port !== 'number' || typeof database !== 'string') {
+  if (typeof database !== 'string') {
     throw new DoltConnectionError(
-      `${metadataPath} is missing required fields: dolt_server_port (number) and dolt_database (string)`
+      `${metadataPath} is missing required field: dolt_database (string)`
     );
   }
 
+  // Try port file first (preferred by bd), fall back to metadata.json
+  let port: number;
+  try {
+    const portPath = path.join(projectRoot, '.beads', 'dolt-server.port');
+    const portRaw = await fs.readFile(portPath, 'utf-8');
+    const portNum = parseInt(portRaw.trim(), 10);
+    if (!isNaN(portNum) && portNum > 0) {
+      port = portNum;
+    } else {
+      // Fall back to metadata.json port
+      const metadataPort = parsed.dolt_server_port;
+      if (typeof metadataPort !== 'number') {
+        throw new DoltConnectionError(
+          `${metadataPath} is missing valid port and .beads/dolt-server.port is missing or invalid`
+        );
+      }
+      port = metadataPort;
+    }
+  } catch {
+    // Fall back to metadata.json port
+    const metadataPort = parsed.dolt_server_port;
+    if (typeof metadataPort !== 'number') {
+      throw new DoltConnectionError(
+        `${metadataPath} is missing required field: dolt_server_port (number) and .beads/dolt-server.port is missing`
+      );
+    }
+    port = metadataPort;
+  }
+
   return {
     dolt_server_port: port,
     dolt_database: database,
diff --git a/src/lib/embedded-daemon.ts b/src/lib/embedded-daemon.ts
new file mode 100644
index 0000000..8a98b9b
--- /dev/null
+++ b/src/lib/embedded-daemon.ts
@@ -0,0 +1,156 @@
+import { buildLaunchRequest, createLaunchConsoleEvents, createOrchestratorInstance, type LaunchSurface, type RuntimeConsoleEvent, type RuntimeInstance } from './embedded-runtime';
+import type { BeadIssue } from './types';
+
+export interface ProjectRuntimeState {
+  projectRoot: string;
+  orchestrator: RuntimeInstance;
+  events: RuntimeConsoleEvent[];
+  updatedAt: string;
+}
+
+export interface HostDaemonStatus {
+  ok: true;
+  daemon: {
+    backend: 'pi';
+    status: 'online';
+    projectCount: number;
+  };
+  projects: Array<{
+    projectRoot: string;
+    orchestratorId: string;
+    orchestratorStatus: RuntimeInstance['status'];
+    eventCount: number;
+    updatedAt: string;
+  }>;
+}
+
+export class EmbeddedPiDaemon {
+  private readonly projects = new Map<string, ProjectRuntimeState>();
+  private readonly orchestratorBooted = new Set<string>();
+
+  ensureProject(projectRoot: string): ProjectRuntimeState {
+    const existing = this.projects.get(projectRoot);
+    if (existing) {
+      return existing;
+    }
+
+    const orchestrator = createOrchestratorInstance(projectRoot);
+    const state: ProjectRuntimeState = {
+      projectRoot,
+      orchestrator,
+      events: [],
+      updatedAt: new Date().toISOString(),
+    };
+    this.projects.set(projectRoot, state);
+    return state;
+  }
+
+  ensureOrchestrator(projectRoot: string): RuntimeInstance {
+    const state = this.ensureProject(projectRoot);
+    const projectId = state.orchestrator.projectId;
+
+    // Only add boot event once per project (track via Set)
+    if (!this.orchestratorBooted.has(projectId)) {
+      state.events.unshift({
+        id: `${projectId}:boot:${Date.now()}-${Math.random().toString(36).slice(2, 8)}`,
+        projectId,
+        kind: 'launch.started',
+        title: 'Host daemon attached project orchestrator',
+        detail: 'BeadBoard host bridge registered project orchestrator.',
+        timestamp: new Date().toISOString(),
+        status: 'idle',
+        actorLabel: state.orchestrator.label,
+      });
+      state.updatedAt = new Date().toISOString();
+      this.orchestratorBooted.add(projectId);
+    }
+    return state.orchestrator;
+  }
+
+  launchFromIssue(params: {
+    projectRoot: string;
+    issue: BeadIssue;
+    origin: LaunchSurface;
+    swarmId?: string | null;
+  }): { orchestrator: RuntimeInstance; events: RuntimeConsoleEvent[] } {
+    const state = this.ensureProject(params.projectRoot);
+    state.orchestrator.status = 'planning';
+
+    const request = buildLaunchRequest({
+      issue: params.issue,
+      origin: params.origin,
+      projectRoot: params.projectRoot,
+      swarmId: params.swarmId ?? null,
+    });
+
+    const launchEvents = createLaunchConsoleEvents(request);
+    state.events.unshift(...launchEvents);
+    state.updatedAt = new Date().toISOString();
+
+    return {
+      orchestrator: state.orchestrator,
+      events: launchEvents,
+    };
+  }
+
+  listEvents(projectRoot: string): RuntimeConsoleEvent[] {
+    return [...(this.projects.get(projectRoot)?.events ?? [])];
+  }
+
+  appendEvent(projectRoot: string, event: Omit<RuntimeConsoleEvent, 'id' | 'timestamp' | 'projectId'>): void {
+    const state = this.ensureProject(projectRoot);
+    const fullEvent: RuntimeConsoleEvent = {
+      ...event,
+      id: `evt-${Date.now()}-${Math.random().toString(36).slice(2, 8)}`,
+      projectId: state.orchestrator.projectId,
+      timestamp: new Date().toISOString(),
+    };
+    state.events.unshift(fullEvent);
+    state.updatedAt = new Date().toISOString();
+  }
+
+  appendWorkerEvent(projectRoot: string, workerId: string, event: {
+    kind: 'worker.spawned' | 'worker.updated' | 'worker.completed' | 'worker.failed';
+    title: string;
+    detail: string;
+    status?: RuntimeConsoleEvent['status'];
+    metadata?: Record<string, unknown>;
+  }): void {
+    this.appendEvent(projectRoot, {
+      ...event,
+      metadata: { workerId, ...(event.metadata || {}) },
+    });
+  }
+
+  getStatus(): HostDaemonStatus {
+    return {
+      ok: true,
+      daemon: {
+        backend: 'pi',
+        status: 'online',
+        projectCount: this.projects.size,
+      },
+      projects: [...this.projects.values()].map((state) => ({
+        projectRoot: state.projectRoot,
+        orchestratorId: state.orchestrator.id,
+        orchestratorStatus: state.orchestrator.status,
+        eventCount: state.events.length,
+        updatedAt: state.updatedAt,
+      })),
+    };
+  }
+
+  resetForTests(): void {
+    this.projects.clear();
+    this.orchestratorBooted.clear();
+  }
+}
+
+const globalRegistry = globalThis as typeof globalThis & {
+  __beadboardEmbeddedPiDaemon?: EmbeddedPiDaemon;
+};
+
+export const embeddedPiDaemon = globalRegistry.__beadboardEmbeddedPiDaemon ?? new EmbeddedPiDaemon();
+if (!globalRegistry.__beadboardEmbeddedPiDaemon) {
+  globalRegistry.__beadboardEmbeddedPiDaemon = embeddedPiDaemon;
+}
diff --git a/src/lib/embedded-runtime.ts b/src/lib/embedded-runtime.ts
new file mode 100644
index 0000000..24b5a05
--- /dev/null
+++ b/src/lib/embedded-runtime.ts
@@ -0,0 +1,238 @@
+import type { BeadIssue } from './types';
+
+export type RuntimeBackendId = 'pi';
+export type AgentInstanceKind = 'orchestrator' | 'worker';
+export type LaunchSurface = 'social' | 'graph' | 'swarm' | 'sessions' | 'activity' | 'task';
+export type RuntimeEventKind =
+  | 'orchestrator.message'
+  | 'launch.requested'
+  | 'launch.planned'
+  | 'launch.started'
+  | 'worker.spawned'
+  | 'worker.updated'
+  | 'worker.completed'
+  | 'worker.failed'
+  | 'deviation.proposed'
+  | 'deviation.approved'
+  | 'deviation.rejected';
+
+export type RuntimeStatus =
+  | 'idle'
+  | 'planning'
+  | 'launching'
+  | 'working'
+  | 'waiting'
+  | 'blocked'
+  | 'completed'
+  | 'failed'
+  | 'stale';
+
+export type TemplateDeviationSeverity = 'minor' | 'major';
+
+export interface AgentTypeDefinition {
+  id: string;
+  archetypeId: string;
+  label: string;
+  backend: RuntimeBackendId;
+  defaultModel?: string | null;
+}
+
+export interface RuntimeInstance {
+  id: string;
+  projectId: string;
+  backend: RuntimeBackendId;
+  kind: AgentInstanceKind;
+  agentTypeId: string;
+  label: string;
+  status: RuntimeStatus;
+  taskId: string | null;
+  epicId: string | null;
+  swarmId: string | null;
+}
+
+export interface LaunchRequest {
+  id: string;
+  projectId: string;
+  backend: RuntimeBackendId;
+  origin: LaunchSurface;
+  taskId: string;
+  epicId: string | null;
+  swarmId: string | null;
+  templateId: string | null;
+  requestedAgentTypeId: string | null;
+  contextSummary: string;
+  issueTitle: string;
+  dependencyIds: string[];
+  createdAt: string;
+}
+
+export interface TemplateDeviationRecord {
+  id: string;
+  launchRequestId: string;
+  severity: TemplateDeviationSeverity;
+  summary: string;
+  reason: string;
+  requiresApproval: boolean;
+  createdAt: string;
+}
+
+export interface RuntimeConsoleEvent {
+  id: string;
+  projectId: string;
+  kind: RuntimeEventKind;
+  title: string;
+  detail: string;
+  timestamp: string;
+  status?: RuntimeStatus;
+  actorLabel?: string;
+  taskId?: string | null;
+  swarmId?: string | null;
+  metadata?: Record<string, unknown>;
+}
+
+function stableProjectId(projectRoot: string): string {
+  return projectRoot
+    .replace(/^[A-Za-z]:/, '')
+    .replaceAll('\\', '/')
+    .split('/')
+    .filter(Boolean)
+    .join('-')
+    .replace(/[^a-zA-Z0-9-]/g, '-')
+    .replace(/-+/g, '-')
+    .toLowerCase() || 'root';
+}
+
+export function getProjectRuntimeId(projectRoot: string): string {
+  // Client-safe path normalization (removes trailing slashes)
+  const normalizedRoot = projectRoot.replace(/[/\\]+$/, '') || projectRoot;
+  return stableProjectId(normalizedRoot);
+}
+
+export function getOrchestratorAgentType(): AgentTypeDefinition {
+  return {
+    id: 'pi-orchestrator',
+    archetypeId: 'orchestrator',
+    label: 'Project Orchestrator',
+    backend: 'pi',
+    defaultModel: null,
+  };
+}
+
+export function createOrchestratorInstance(projectRoot: string): RuntimeInstance {
+  const projectId = getProjectRuntimeId(projectRoot);
+  return {
+    id: `${projectId}:orchestrator`,
+    projectId,
+    backend: 'pi',
+    kind: 'orchestrator',
+    agentTypeId: getOrchestratorAgentType().id,
+    label: 'Main Orchestrator',
+    status: 'idle',
+    taskId: null,
+    epicId: null,
+    swarmId: null,
+  };
+}
+
+export function buildLaunchRequest(params: {
+  issue: BeadIssue;
+  origin: LaunchSurface;
+  projectRoot: string;
+  swarmId?: string | null;
+  requestedAgentTypeId?: string | null;
+}): LaunchRequest {
+  const { issue, origin, projectRoot, swarmId = null, requestedAgentTypeId = null } = params;
+  const projectId = getProjectRuntimeId(projectRoot);
+  const epicId = issue.dependencies.find((dep) => dep.type === 'parent')?.target ?? null;
+  const dependencyIds = issue.dependencies
+    .filter((dep) => dep.type !== 'parent')
+    .map((dep) => dep.target)
+    .sort();
+
+  return {
+    id: `${projectId}:${origin}:${issue.id}`,
+    projectId,
+    backend: 'pi',
+    origin,
+    taskId: issue.id,
+    epicId,
+    swarmId,
+    templateId: issue.templateId ?? null,
+    requestedAgentTypeId,
+    contextSummary: `Launch ${issue.id} from ${origin} with ${dependencyIds.length} dependency link(s).`,
+    issueTitle: issue.title,
+    dependencyIds,
+    createdAt: new Date().toISOString(),
+  };
+}
+
+export function createDeviationRecord(params: {
+  launchRequest: LaunchRequest;
+  severity: TemplateDeviationSeverity;
+  summary: string;
+  reason: string;
+}): TemplateDeviationRecord {
+  const { launchRequest, severity, summary, reason } = params;
+  return {
+    id: `${launchRequest.id}:deviation`,
+    launchRequestId: launchRequest.id,
+    severity,
+    summary,
+    reason,
+    requiresApproval: severity === 'major',
+    createdAt: new Date().toISOString(),
+  };
+}
+
+export function createRuntimeConsoleEvent(params: {
+  projectId: string;
+  kind: RuntimeEventKind;
+  title: string;
+  detail: string;
+  status?: RuntimeStatus;
+  actorLabel?: string;
+  taskId?: string | null;
+  swarmId?: string | null;
+  metadata?: Record<string, unknown>;
+}): RuntimeConsoleEvent {
+  const { projectId, kind, title, detail, status, actorLabel, taskId = null, swarmId = null, metadata } = params;
+  return {
+    id: `${projectId}:${kind}:${taskId ?? 'global'}:${Date.now()}`,
+    projectId,
+    kind,
+    title,
+    detail,
+    timestamp: new Date().toISOString(),
+    status,
+    actorLabel,
+    taskId,
+    swarmId,
+    metadata,
+  };
+}
+
+export function createLaunchConsoleEvents(request: LaunchRequest): RuntimeConsoleEvent[] {
+  return [
+    createRuntimeConsoleEvent({
+      projectId: request.projectId,
+      kind: 'launch.requested',
+      title: `Launch requested for ${request.taskId}`,
+      detail: `${request.issueTitle} queued from ${request.origin}.`,
+      status: 'planning',
+      actorLabel: 'Main Orchestrator',
+      taskId: request.taskId,
+      swarmId: request.swarmId,
+      metadata: { templateId: request.templateId, requestedAgentTypeId: request.requestedAgentTypeId },
+    }),
+    createRuntimeConsoleEvent({
+      projectId: request.projectId,
+      kind: 'orchestrator.message',
+      title: 'Orchestrator reviewing launch context',
+      detail: request.contextSummary,
+      status: 'planning',
+      actorLabel: 'Main Orchestrator',
+      taskId: request.taskId,
+      swarmId: request.swarmId,
+    }),
+  ];
+}
